      subroutine bldxu(deg,xupt,yupt,wupt,nxupt)
      implicit none
c
c     build acos(Xu points) on [-1,1]^2 
c     left-right, bottom-up
c
      integer deg,nxupt
c
c     deg   (i) degree 
c     nxupt (o) number of Xu points
c
      double precision pi
      parameter (pi=3.141592653589793d0)
      double precision xupt(*),yupt(*),wupt(*)
c
c     xupt  (o) first coord. of Xu points
c     yupt  (o) second coord. of Xu points
c
      integer i,j,itemp0,itemp
      double precision rtemp0,rtemp1
      intrinsic mod,cos
      if (mod(deg,2).ne.0) then
         write(6,*) 'deg must be even.'
         stop
      end if   
      itemp0=deg**2
      rtemp0=pi/deg
      nxupt=0
      j=deg
      rtemp1=j*rtemp0
      do i=deg-1,1,-2
         nxupt=nxupt+1
         xupt(nxupt)=i*rtemp0
         yupt(nxupt)=rtemp1
         wupt(nxupt)=0.5d0/itemp0
      end do
      do j=deg-1,1,-1
         rtemp1=j*rtemp0
         itemp=mod(j,2)
         i=deg-1+itemp
         nxupt=nxupt+1
         xupt(nxupt)=i*rtemp0
         yupt(nxupt)=rtemp1
         wupt(nxupt)=(1-itemp*0.5d0)/itemp0
         do i=deg-1+itemp-2,1-itemp+2,-2
            nxupt=nxupt+1
            xupt(nxupt)=i*rtemp0
            yupt(nxupt)=rtemp1
            wupt(nxupt)=1.0d0/itemp0
         end do
         i=1-itemp
         nxupt=nxupt+1
         xupt(nxupt)=i*rtemp0
         yupt(nxupt)=rtemp1
         wupt(nxupt)=(1-itemp*0.5d0)/itemp0
      end do   
      j=0
      do i=deg-1,1,-2
         nxupt=nxupt+1
         xupt(nxupt)=i*rtemp0
         yupt(nxupt)=0.0d0
         wupt(nxupt)=0.5d0/itemp0
      end do
      return
      end
