      subroutine interp(deg,xupt,yupt,wupt,fxupt,nxupt,xtgpt,ytgpt,
     1     ftgpt,ntgpt,scale1,shift1,scale2,shift2)
      implicit none
c
c     Xu interpolant on domain scale1*[-1:1]+shift1 x scale2*[-1:1]+shift2
c
c     parameters:
c
c     deg     (i)   degree of polynomial interpolation
c     xupt    (i/o) first coord. of acos(Xu points on [-1:1]^2)
c     yupt    (i/o) second coor. of acos(Xu points on [-1:1]^2)
c     fxupt   (i/o) funcion (scale1*cos(xupt)+shift1,scale2*cos(yupt)+shift2)
c     nxupt   (i)   number of Xu points
c     tgpt    (i)   target points
c     ftgpt   (o)   values of interpolant on target points
c     ntgpt   (i)   number of target points
c     scale   (i)   scales and shift

c
      integer deg,nxupt,ntgpt
c      
      double precision scale1,shift1,scale2,shift2,pi
      parameter (pi=3.141592653589793d0)
      double precision xupt(nxupt),yupt(nxupt),fxupt(nxupt),wupt(nxupt),
     1     xtgpt(ntgpt),ytgpt(ntgpt),ftgpt(ntgpt)
c     
c     local variables
c
      integer i,j,k,l,itemp,deg2,itemp1
c
      double precision rtemp1,
     1     lag,tgpt1,tgpt2,xupt1,xupt2
      intrinsic mod,acos
      external lagran
c     
c     executable statements
c
      if (mod(deg,2).ne.0) then
         write(6,*) 'deg must be even.'
         stop
      end if
      deg2=deg**2
c     
c     interpolation
c
      itemp1=2*deg2
      do k=1,ntgpt
c     to prevent acos(>1,<-1) = NaN
         tgpt1=acos(max(min((xtgpt(k)-shift1)/scale1,1.d0),-1.d0))
         tgpt2=acos(max(min((ytgpt(k)-shift2)/scale2,1.d0),-1.d0))
         rtemp1=0.d0        
         l=1
         do j=deg,0,-1
            xupt2=yupt(l)
            itemp=mod(j,2)
            do i=deg-1+itemp,1-itemp,-2
               xupt1=xupt(l)
               call lagran(lag,deg,i,xupt1,xupt2,tgpt1,tgpt2)
               rtemp1=rtemp1+lag*fxupt(l)*wupt(l)
               l=l+1
            end do
         end do
         ftgpt(k)=rtemp1
      end do   
      return
      end
